# ory-oathkeeper-client
ORY Oathkeeper is a reverse proxy that checks the HTTP Authorization for validity against a set of rules. This service uses Hydra to validate access tokens and policies.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.0.0-alpha.37
- Package version: v0.0.0-alpha.37
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://www.ory.am](https://www.ory.am)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/ory/sdk.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/ory/sdk.git`)

Then import the package:
```python
import ory_oathkeeper_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import ory_oathkeeper_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import ory_oathkeeper_client
from ory_oathkeeper_client.rest import ApiException
from pprint import pprint


# Defining host is optional and default to http://localhost
configuration.host = "http://localhost"
# Create an instance of the API class
api_instance = ory_oathkeeper_client.ApiApi(ory_oathkeeper_client.ApiClient(configuration))

try:
    # Access Control Decision API
    api_instance.decisions()
except ApiException as e:
    print("Exception when calling ApiApi->decisions: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApiApi* | [**decisions**](docs/ApiApi.md#decisions) | **GET** /decisions | Access Control Decision API
*ApiApi* | [**get_rule**](docs/ApiApi.md#get_rule) | **GET** /rules/{id} | Retrieve a rule
*ApiApi* | [**get_version**](docs/ApiApi.md#get_version) | **GET** /version | Get service version
*ApiApi* | [**get_well_known_json_web_keys**](docs/ApiApi.md#get_well_known_json_web_keys) | **GET** /.well-known/jwks.json | Lists cryptographic keys
*ApiApi* | [**is_instance_alive**](docs/ApiApi.md#is_instance_alive) | **GET** /health/alive | Check alive status
*ApiApi* | [**is_instance_ready**](docs/ApiApi.md#is_instance_ready) | **GET** /health/ready | Check readiness status
*ApiApi* | [**list_rules**](docs/ApiApi.md#list_rules) | **GET** /rules | List all rules


## Documentation For Models

 - [CreateRuleCreated](docs/CreateRuleCreated.md)
 - [CreateRuleForbidden](docs/CreateRuleForbidden.md)
 - [CreateRuleForbiddenBody](docs/CreateRuleForbiddenBody.md)
 - [CreateRuleInternalServerError](docs/CreateRuleInternalServerError.md)
 - [CreateRuleInternalServerErrorBody](docs/CreateRuleInternalServerErrorBody.md)
 - [CreateRuleUnauthorized](docs/CreateRuleUnauthorized.md)
 - [CreateRuleUnauthorizedBody](docs/CreateRuleUnauthorizedBody.md)
 - [DecisionsForbidden](docs/DecisionsForbidden.md)
 - [DecisionsForbiddenBody](docs/DecisionsForbiddenBody.md)
 - [DecisionsInternalServerError](docs/DecisionsInternalServerError.md)
 - [DecisionsInternalServerErrorBody](docs/DecisionsInternalServerErrorBody.md)
 - [DecisionsNotFound](docs/DecisionsNotFound.md)
 - [DecisionsNotFoundBody](docs/DecisionsNotFoundBody.md)
 - [DecisionsUnauthorized](docs/DecisionsUnauthorized.md)
 - [DecisionsUnauthorizedBody](docs/DecisionsUnauthorizedBody.md)
 - [DeleteRuleForbidden](docs/DeleteRuleForbidden.md)
 - [DeleteRuleForbiddenBody](docs/DeleteRuleForbiddenBody.md)
 - [DeleteRuleInternalServerError](docs/DeleteRuleInternalServerError.md)
 - [DeleteRuleInternalServerErrorBody](docs/DeleteRuleInternalServerErrorBody.md)
 - [DeleteRuleNotFound](docs/DeleteRuleNotFound.md)
 - [DeleteRuleNotFoundBody](docs/DeleteRuleNotFoundBody.md)
 - [DeleteRuleUnauthorized](docs/DeleteRuleUnauthorized.md)
 - [DeleteRuleUnauthorizedBody](docs/DeleteRuleUnauthorizedBody.md)
 - [GetRuleForbidden](docs/GetRuleForbidden.md)
 - [GetRuleForbiddenBody](docs/GetRuleForbiddenBody.md)
 - [GetRuleInternalServerError](docs/GetRuleInternalServerError.md)
 - [GetRuleInternalServerErrorBody](docs/GetRuleInternalServerErrorBody.md)
 - [GetRuleNotFound](docs/GetRuleNotFound.md)
 - [GetRuleNotFoundBody](docs/GetRuleNotFoundBody.md)
 - [GetRuleOK](docs/GetRuleOK.md)
 - [GetRuleUnauthorized](docs/GetRuleUnauthorized.md)
 - [GetRuleUnauthorizedBody](docs/GetRuleUnauthorizedBody.md)
 - [GetWellKnownForbidden](docs/GetWellKnownForbidden.md)
 - [GetWellKnownForbiddenBody](docs/GetWellKnownForbiddenBody.md)
 - [GetWellKnownJSONWebKeysInternalServerError](docs/GetWellKnownJSONWebKeysInternalServerError.md)
 - [GetWellKnownJSONWebKeysInternalServerErrorBody](docs/GetWellKnownJSONWebKeysInternalServerErrorBody.md)
 - [GetWellKnownJSONWebKeysOK](docs/GetWellKnownJSONWebKeysOK.md)
 - [GetWellKnownOK](docs/GetWellKnownOK.md)
 - [GetWellKnownUnauthorized](docs/GetWellKnownUnauthorized.md)
 - [GetWellKnownUnauthorizedBody](docs/GetWellKnownUnauthorizedBody.md)
 - [HealthNotReadyStatus](docs/HealthNotReadyStatus.md)
 - [HealthStatus](docs/HealthStatus.md)
 - [InlineResponse500](docs/InlineResponse500.md)
 - [IsInstanceAliveInternalServerError](docs/IsInstanceAliveInternalServerError.md)
 - [IsInstanceAliveInternalServerErrorBody](docs/IsInstanceAliveInternalServerErrorBody.md)
 - [IsInstanceAliveOK](docs/IsInstanceAliveOK.md)
 - [JsonWebKey](docs/JsonWebKey.md)
 - [JsonWebKeySet](docs/JsonWebKeySet.md)
 - [JudgeForbidden](docs/JudgeForbidden.md)
 - [JudgeForbiddenBody](docs/JudgeForbiddenBody.md)
 - [JudgeInternalServerError](docs/JudgeInternalServerError.md)
 - [JudgeInternalServerErrorBody](docs/JudgeInternalServerErrorBody.md)
 - [JudgeNotFound](docs/JudgeNotFound.md)
 - [JudgeNotFoundBody](docs/JudgeNotFoundBody.md)
 - [JudgeUnauthorized](docs/JudgeUnauthorized.md)
 - [JudgeUnauthorizedBody](docs/JudgeUnauthorizedBody.md)
 - [ListRulesForbidden](docs/ListRulesForbidden.md)
 - [ListRulesForbiddenBody](docs/ListRulesForbiddenBody.md)
 - [ListRulesInternalServerError](docs/ListRulesInternalServerError.md)
 - [ListRulesInternalServerErrorBody](docs/ListRulesInternalServerErrorBody.md)
 - [ListRulesOK](docs/ListRulesOK.md)
 - [ListRulesUnauthorized](docs/ListRulesUnauthorized.md)
 - [ListRulesUnauthorizedBody](docs/ListRulesUnauthorizedBody.md)
 - [Rule](docs/Rule.md)
 - [RuleHandler](docs/RuleHandler.md)
 - [RuleMatch](docs/RuleMatch.md)
 - [SwaggerCreateRuleParameters](docs/SwaggerCreateRuleParameters.md)
 - [SwaggerGetRuleParameters](docs/SwaggerGetRuleParameters.md)
 - [SwaggerHealthStatus](docs/SwaggerHealthStatus.md)
 - [SwaggerJSONWebKey](docs/SwaggerJSONWebKey.md)
 - [SwaggerJSONWebKeySet](docs/SwaggerJSONWebKeySet.md)
 - [SwaggerListRulesParameters](docs/SwaggerListRulesParameters.md)
 - [SwaggerNotReadyStatus](docs/SwaggerNotReadyStatus.md)
 - [SwaggerRule](docs/SwaggerRule.md)
 - [SwaggerRuleHandler](docs/SwaggerRuleHandler.md)
 - [SwaggerRuleMatch](docs/SwaggerRuleMatch.md)
 - [SwaggerRuleResponse](docs/SwaggerRuleResponse.md)
 - [SwaggerRulesResponse](docs/SwaggerRulesResponse.md)
 - [SwaggerUpdateRuleParameters](docs/SwaggerUpdateRuleParameters.md)
 - [SwaggerVersion](docs/SwaggerVersion.md)
 - [UpdateRuleForbidden](docs/UpdateRuleForbidden.md)
 - [UpdateRuleForbiddenBody](docs/UpdateRuleForbiddenBody.md)
 - [UpdateRuleInternalServerError](docs/UpdateRuleInternalServerError.md)
 - [UpdateRuleInternalServerErrorBody](docs/UpdateRuleInternalServerErrorBody.md)
 - [UpdateRuleNotFound](docs/UpdateRuleNotFound.md)
 - [UpdateRuleNotFoundBody](docs/UpdateRuleNotFoundBody.md)
 - [UpdateRuleOK](docs/UpdateRuleOK.md)
 - [UpdateRuleUnauthorized](docs/UpdateRuleUnauthorized.md)
 - [UpdateRuleUnauthorizedBody](docs/UpdateRuleUnauthorizedBody.md)
 - [Upstream](docs/Upstream.md)
 - [Version](docs/Version.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

hi@ory.am


