# coding: utf-8

"""
    ORY Oathkeeper

    ORY Oathkeeper is a reverse proxy that checks the HTTP Authorization for validity against a set of rules. This service uses Hydra to validate access tokens and policies.  # noqa: E501

    The version of the OpenAPI document: v0.0.0-alpha.37
    Contact: hi@ory.am
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ory_oathkeeper_client.configuration import Configuration


class RuleHandler(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'config': 'object',
        'handler': 'str'
    }

    attribute_map = {
        'config': 'config',
        'handler': 'handler'
    }

    def __init__(self, config=None, handler=None, local_vars_configuration=None):  # noqa: E501
        """RuleHandler - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._config = None
        self._handler = None
        self.discriminator = None

        if config is not None:
            self.config = config
        if handler is not None:
            self.handler = handler

    @property
    def config(self):
        """Gets the config of this RuleHandler.  # noqa: E501

        Config contains the configuration for the handler. Please read the user guide for a complete list of each handler's available settings.  # noqa: E501

        :return: The config of this RuleHandler.  # noqa: E501
        :rtype: object
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this RuleHandler.

        Config contains the configuration for the handler. Please read the user guide for a complete list of each handler's available settings.  # noqa: E501

        :param config: The config of this RuleHandler.  # noqa: E501
        :type: object
        """

        self._config = config

    @property
    def handler(self):
        """Gets the handler of this RuleHandler.  # noqa: E501

        Handler identifies the implementation which will be used to handle this specific request. Please read the user guide for a complete list of available handlers.  # noqa: E501

        :return: The handler of this RuleHandler.  # noqa: E501
        :rtype: str
        """
        return self._handler

    @handler.setter
    def handler(self, handler):
        """Sets the handler of this RuleHandler.

        Handler identifies the implementation which will be used to handle this specific request. Please read the user guide for a complete list of available handlers.  # noqa: E501

        :param handler: The handler of this RuleHandler.  # noqa: E501
        :type: str
        """

        self._handler = handler

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RuleHandler):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RuleHandler):
            return True

        return self.to_dict() != other.to_dict()
